using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse200
    /// </summary>
    public sealed class InlineResponse200:  IEquatable<InlineResponse200>
    { 
        /// <summary>
        /// Планируемое количество дней до наступления негативного баланса
        /// </summary>
        public int? NegativeBalanceDays { get; private set; }

        /// <summary>
        /// Планируемое количество дней до наступления негативного баланса по аккаунту лицензий
        /// </summary>
        public int? NegativeBalanceDaysLic { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public decimal? LastMonthDebtSum { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public decimal? LastMonthDebtSum2 { get; private set; }

        /// <summary>
        /// Дата блокировки аккаунта
        /// </summary>
        public string BlockDate { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse200.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse200()
        {
        }

        private InlineResponse200(int? NegativeBalanceDays, int? NegativeBalanceDaysLic, decimal? LastMonthDebtSum, decimal? LastMonthDebtSum2, string BlockDate)
        {
            
            this.NegativeBalanceDays = NegativeBalanceDays;
            
            this.NegativeBalanceDaysLic = NegativeBalanceDaysLic;
            
            this.LastMonthDebtSum = LastMonthDebtSum;
            
            this.LastMonthDebtSum2 = LastMonthDebtSum2;
            
            this.BlockDate = BlockDate;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse200.
        /// </summary>
        /// <returns>InlineResponse200Builder</returns>
        public static InlineResponse200Builder Builder()
        {
            return new InlineResponse200Builder();
        }

        /// <summary>
        /// Returns InlineResponse200Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse200Builder</returns>
        public InlineResponse200Builder With()
        {
            return Builder()
                .NegativeBalanceDays(NegativeBalanceDays)
                .NegativeBalanceDaysLic(NegativeBalanceDaysLic)
                .LastMonthDebtSum(LastMonthDebtSum)
                .LastMonthDebtSum2(LastMonthDebtSum2)
                .BlockDate(BlockDate);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse200 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse200.
        /// </summary>
        /// <param name="left">Compared (InlineResponse200</param>
        /// <param name="right">Compared (InlineResponse200</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse200 left, InlineResponse200 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse200.
        /// </summary>
        /// <param name="left">Compared (InlineResponse200</param>
        /// <param name="right">Compared (InlineResponse200</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse200 left, InlineResponse200 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse200.
        /// </summary>
        public sealed class InlineResponse200Builder
        {
            private int? _NegativeBalanceDays;
            private int? _NegativeBalanceDaysLic;
            private decimal? _LastMonthDebtSum;
            private decimal? _LastMonthDebtSum2;
            private string _BlockDate;

            internal InlineResponse200Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse200.NegativeBalanceDays property.
            /// </summary>
            /// <param name="value">Планируемое количество дней до наступления негативного баланса</param>
            public InlineResponse200Builder NegativeBalanceDays(int? value)
            {
                _NegativeBalanceDays = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse200.NegativeBalanceDaysLic property.
            /// </summary>
            /// <param name="value">Планируемое количество дней до наступления негативного баланса по аккаунту лицензий</param>
            public InlineResponse200Builder NegativeBalanceDaysLic(int? value)
            {
                _NegativeBalanceDaysLic = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse200.LastMonthDebtSum property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse200Builder LastMonthDebtSum(decimal? value)
            {
                _LastMonthDebtSum = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse200.LastMonthDebtSum2 property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse200Builder LastMonthDebtSum2(decimal? value)
            {
                _LastMonthDebtSum2 = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse200.BlockDate property.
            /// </summary>
            /// <param name="value">Дата блокировки аккаунта</param>
            public InlineResponse200Builder BlockDate(string value)
            {
                _BlockDate = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse200.
            /// </summary>
            /// <returns>InlineResponse200</returns>
            public InlineResponse200 Build()
            {
                Validate();
                return new InlineResponse200(
                    NegativeBalanceDays: _NegativeBalanceDays,
                    NegativeBalanceDaysLic: _NegativeBalanceDaysLic,
                    LastMonthDebtSum: _LastMonthDebtSum,
                    LastMonthDebtSum2: _LastMonthDebtSum2,
                    BlockDate: _BlockDate
                );
            }

            private void Validate()
            { 
                if (_NegativeBalanceDays == null)
                {
                    throw new ArgumentException("NegativeBalanceDays is a required property for InlineResponse200 and cannot be null");
                } 
                if (_NegativeBalanceDaysLic == null)
                {
                    throw new ArgumentException("NegativeBalanceDaysLic is a required property for InlineResponse200 and cannot be null");
                } 
                if (_LastMonthDebtSum == null)
                {
                    throw new ArgumentException("LastMonthDebtSum is a required property for InlineResponse200 and cannot be null");
                } 
                if (_LastMonthDebtSum2 == null)
                {
                    throw new ArgumentException("LastMonthDebtSum2 is a required property for InlineResponse200 and cannot be null");
                } 
                if (_BlockDate == null)
                {
                    throw new ArgumentException("BlockDate is a required property for InlineResponse200 and cannot be null");
                } 
            }
        }

        
    }
}
