using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2001
    /// </summary>
    public sealed class InlineResponse2001:  IEquatable<InlineResponse2001>
    { 
        /// <summary>
        /// Идентификатор аккаунта
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// Описание аккаунта
        /// </summary>
        public string Description { get; private set; }

        /// <summary>
        /// Идентификатор тарифной группы
        /// </summary>
        public int? BillingGroupId { get; private set; }

        /// <summary>
        /// Аккаунт заблокирован, если true
        /// </summary>
        public string Blocked { get; private set; }

        /// <summary>
        /// Дата блокировки
        /// </summary>
        public string BlockedDate { get; private set; }

        /// <summary>
        /// Причина блокировки
        /// </summary>
        public string BlockedReason { get; private set; }

        /// <summary>
        /// Ограничение суммы на работу в аванс
        /// </summary>
        public decimal? CreditLimit { get; private set; }

        /// <summary>
        /// Идентификатор тарифа
        /// </summary>
        public int? PlanId { get; private set; }

        /// <summary>
        /// Идентификатор тарифа (периода)
        /// </summary>
        public int? PeriodId { get; private set; }

        /// <summary>
        /// Тип договора
        /// </summary>
        public int? ContractType { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? ClientId { get; private set; }

        /// <summary>
        /// Логин клиента
        /// </summary>
        public string ClientLogin { get; private set; }

        /// <summary>
        /// Номер договора
        /// </summary>
        public string ContractId { get; private set; }

        /// <summary>
        /// Имя клиента на русском
        /// </summary>
        public string NameRus { get; private set; }

        /// <summary>
        /// Имя клиента на английском
        /// </summary>
        public string NameEng { get; private set; }

        /// <summary>
        /// E-mail клиент
        /// </summary>
        public string Email { get; private set; }

        /// <summary>
        /// Количество созданных сайтов
        /// </summary>
        public int? StatSites { get; private set; }

        /// <summary>
        /// Используемое дисковое пространство
        /// </summary>
        public int? StatSizeMb { get; private set; }

        /// <summary>
        /// Количество созданных почтовых ящиков
        /// </summary>
        public int? StatEmails { get; private set; }

        /// <summary>
        /// Количество баз данных MySQL
        /// </summary>
        public int? StatMysqls { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? StatTech { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? StatNicd { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? StatAccessDynamic { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? StatAccessStatic { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? StatAccessTraffic { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? StatPaidTotal { get; private set; }

        /// <summary>
        /// Размер дисков VDS
        /// </summary>
        public int? StatVdsSize { get; private set; }

        /// <summary>
        /// Название тарифного плана
        /// </summary>
        public string PlanName { get; private set; }

        /// <summary>
        /// Количество месяцев в оплаченном периоде
        /// </summary>
        public int? PeriodMonths { get; private set; }

        /// <summary>
        /// Стоимость оплаченного периода
        /// </summary>
        public decimal? PeriodPrice { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public string Expires { get; private set; }

        /// <summary>
        /// Префикс для вывода текущей валюты хостинга (например, в строке &#39;$100&#39; префиксом является &#39;$&#39;)
        /// </summary>
        public string ExternalCurrencySpelledPrefix { get; private set; }

        /// <summary>
        /// Суффикс для вывода текущей валюты хостинга (например, в строке &#39;100 руб.&#39; суффиксом является &#39; руб.&#39;
        /// </summary>
        public string ExternalCurrencySpelledSuffix { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2001.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2001()
        {
        }

        private InlineResponse2001(int? Id, string Description, int? BillingGroupId, string Blocked, string BlockedDate, string BlockedReason, decimal? CreditLimit, int? PlanId, int? PeriodId, int? ContractType, int? ClientId, string ClientLogin, string ContractId, string NameRus, string NameEng, string Email, int? StatSites, int? StatSizeMb, int? StatEmails, int? StatMysqls, int? StatTech, int? StatNicd, int? StatAccessDynamic, int? StatAccessStatic, int? StatAccessTraffic, int? StatPaidTotal, int? StatVdsSize, string PlanName, int? PeriodMonths, decimal? PeriodPrice, string Expires, string ExternalCurrencySpelledPrefix, string ExternalCurrencySpelledSuffix)
        {
            
            this.Id = Id;
            
            this.Description = Description;
            
            this.BillingGroupId = BillingGroupId;
            
            this.Blocked = Blocked;
            
            this.BlockedDate = BlockedDate;
            
            this.BlockedReason = BlockedReason;
            
            this.CreditLimit = CreditLimit;
            
            this.PlanId = PlanId;
            
            this.PeriodId = PeriodId;
            
            this.ContractType = ContractType;
            
            this.ClientId = ClientId;
            
            this.ClientLogin = ClientLogin;
            
            this.ContractId = ContractId;
            
            this.NameRus = NameRus;
            
            this.NameEng = NameEng;
            
            this.Email = Email;
            
            this.StatSites = StatSites;
            
            this.StatSizeMb = StatSizeMb;
            
            this.StatEmails = StatEmails;
            
            this.StatMysqls = StatMysqls;
            
            this.StatTech = StatTech;
            
            this.StatNicd = StatNicd;
            
            this.StatAccessDynamic = StatAccessDynamic;
            
            this.StatAccessStatic = StatAccessStatic;
            
            this.StatAccessTraffic = StatAccessTraffic;
            
            this.StatPaidTotal = StatPaidTotal;
            
            this.StatVdsSize = StatVdsSize;
            
            this.PlanName = PlanName;
            
            this.PeriodMonths = PeriodMonths;
            
            this.PeriodPrice = PeriodPrice;
            
            this.Expires = Expires;
            
            this.ExternalCurrencySpelledPrefix = ExternalCurrencySpelledPrefix;
            
            this.ExternalCurrencySpelledSuffix = ExternalCurrencySpelledSuffix;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2001.
        /// </summary>
        /// <returns>InlineResponse2001Builder</returns>
        public static InlineResponse2001Builder Builder()
        {
            return new InlineResponse2001Builder();
        }

        /// <summary>
        /// Returns InlineResponse2001Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2001Builder</returns>
        public InlineResponse2001Builder With()
        {
            return Builder()
                .Id(Id)
                .Description(Description)
                .BillingGroupId(BillingGroupId)
                .Blocked(Blocked)
                .BlockedDate(BlockedDate)
                .BlockedReason(BlockedReason)
                .CreditLimit(CreditLimit)
                .PlanId(PlanId)
                .PeriodId(PeriodId)
                .ContractType(ContractType)
                .ClientId(ClientId)
                .ClientLogin(ClientLogin)
                .ContractId(ContractId)
                .NameRus(NameRus)
                .NameEng(NameEng)
                .Email(Email)
                .StatSites(StatSites)
                .StatSizeMb(StatSizeMb)
                .StatEmails(StatEmails)
                .StatMysqls(StatMysqls)
                .StatTech(StatTech)
                .StatNicd(StatNicd)
                .StatAccessDynamic(StatAccessDynamic)
                .StatAccessStatic(StatAccessStatic)
                .StatAccessTraffic(StatAccessTraffic)
                .StatPaidTotal(StatPaidTotal)
                .StatVdsSize(StatVdsSize)
                .PlanName(PlanName)
                .PeriodMonths(PeriodMonths)
                .PeriodPrice(PeriodPrice)
                .Expires(Expires)
                .ExternalCurrencySpelledPrefix(ExternalCurrencySpelledPrefix)
                .ExternalCurrencySpelledSuffix(ExternalCurrencySpelledSuffix);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2001 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2001.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2001</param>
        /// <param name="right">Compared (InlineResponse2001</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2001 left, InlineResponse2001 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2001.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2001</param>
        /// <param name="right">Compared (InlineResponse2001</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2001 left, InlineResponse2001 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2001.
        /// </summary>
        public sealed class InlineResponse2001Builder
        {
            private int? _Id;
            private string _Description;
            private int? _BillingGroupId;
            private string _Blocked;
            private string _BlockedDate;
            private string _BlockedReason;
            private decimal? _CreditLimit;
            private int? _PlanId;
            private int? _PeriodId;
            private int? _ContractType;
            private int? _ClientId;
            private string _ClientLogin;
            private string _ContractId;
            private string _NameRus;
            private string _NameEng;
            private string _Email;
            private int? _StatSites;
            private int? _StatSizeMb;
            private int? _StatEmails;
            private int? _StatMysqls;
            private int? _StatTech;
            private int? _StatNicd;
            private int? _StatAccessDynamic;
            private int? _StatAccessStatic;
            private int? _StatAccessTraffic;
            private int? _StatPaidTotal;
            private int? _StatVdsSize;
            private string _PlanName;
            private int? _PeriodMonths;
            private decimal? _PeriodPrice;
            private string _Expires;
            private string _ExternalCurrencySpelledPrefix;
            private string _ExternalCurrencySpelledSuffix;

            internal InlineResponse2001Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2001.Id property.
            /// </summary>
            /// <param name="value">Идентификатор аккаунта</param>
            public InlineResponse2001Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.Description property.
            /// </summary>
            /// <param name="value">Описание аккаунта</param>
            public InlineResponse2001Builder Description(string value)
            {
                _Description = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.BillingGroupId property.
            /// </summary>
            /// <param name="value">Идентификатор тарифной группы</param>
            public InlineResponse2001Builder BillingGroupId(int? value)
            {
                _BillingGroupId = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.Blocked property.
            /// </summary>
            /// <param name="value">Аккаунт заблокирован, если true</param>
            public InlineResponse2001Builder Blocked(string value)
            {
                _Blocked = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.BlockedDate property.
            /// </summary>
            /// <param name="value">Дата блокировки</param>
            public InlineResponse2001Builder BlockedDate(string value)
            {
                _BlockedDate = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.BlockedReason property.
            /// </summary>
            /// <param name="value">Причина блокировки</param>
            public InlineResponse2001Builder BlockedReason(string value)
            {
                _BlockedReason = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.CreditLimit property.
            /// </summary>
            /// <param name="value">Ограничение суммы на работу в аванс</param>
            public InlineResponse2001Builder CreditLimit(decimal? value)
            {
                _CreditLimit = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.PlanId property.
            /// </summary>
            /// <param name="value">Идентификатор тарифа</param>
            public InlineResponse2001Builder PlanId(int? value)
            {
                _PlanId = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.PeriodId property.
            /// </summary>
            /// <param name="value">Идентификатор тарифа (периода)</param>
            public InlineResponse2001Builder PeriodId(int? value)
            {
                _PeriodId = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.ContractType property.
            /// </summary>
            /// <param name="value">Тип договора</param>
            public InlineResponse2001Builder ContractType(int? value)
            {
                _ContractType = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.ClientId property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2001Builder ClientId(int? value)
            {
                _ClientId = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.ClientLogin property.
            /// </summary>
            /// <param name="value">Логин клиента</param>
            public InlineResponse2001Builder ClientLogin(string value)
            {
                _ClientLogin = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.ContractId property.
            /// </summary>
            /// <param name="value">Номер договора</param>
            public InlineResponse2001Builder ContractId(string value)
            {
                _ContractId = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.NameRus property.
            /// </summary>
            /// <param name="value">Имя клиента на русском</param>
            public InlineResponse2001Builder NameRus(string value)
            {
                _NameRus = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.NameEng property.
            /// </summary>
            /// <param name="value">Имя клиента на английском</param>
            public InlineResponse2001Builder NameEng(string value)
            {
                _NameEng = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.Email property.
            /// </summary>
            /// <param name="value">E-mail клиент</param>
            public InlineResponse2001Builder Email(string value)
            {
                _Email = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatSites property.
            /// </summary>
            /// <param name="value">Количество созданных сайтов</param>
            public InlineResponse2001Builder StatSites(int? value)
            {
                _StatSites = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatSizeMb property.
            /// </summary>
            /// <param name="value">Используемое дисковое пространство</param>
            public InlineResponse2001Builder StatSizeMb(int? value)
            {
                _StatSizeMb = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatEmails property.
            /// </summary>
            /// <param name="value">Количество созданных почтовых ящиков</param>
            public InlineResponse2001Builder StatEmails(int? value)
            {
                _StatEmails = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatMysqls property.
            /// </summary>
            /// <param name="value">Количество баз данных MySQL</param>
            public InlineResponse2001Builder StatMysqls(int? value)
            {
                _StatMysqls = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatTech property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2001Builder StatTech(int? value)
            {
                _StatTech = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatNicd property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2001Builder StatNicd(int? value)
            {
                _StatNicd = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatAccessDynamic property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2001Builder StatAccessDynamic(int? value)
            {
                _StatAccessDynamic = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatAccessStatic property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2001Builder StatAccessStatic(int? value)
            {
                _StatAccessStatic = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatAccessTraffic property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2001Builder StatAccessTraffic(int? value)
            {
                _StatAccessTraffic = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatPaidTotal property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2001Builder StatPaidTotal(int? value)
            {
                _StatPaidTotal = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.StatVdsSize property.
            /// </summary>
            /// <param name="value">Размер дисков VDS</param>
            public InlineResponse2001Builder StatVdsSize(int? value)
            {
                _StatVdsSize = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.PlanName property.
            /// </summary>
            /// <param name="value">Название тарифного плана</param>
            public InlineResponse2001Builder PlanName(string value)
            {
                _PlanName = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.PeriodMonths property.
            /// </summary>
            /// <param name="value">Количество месяцев в оплаченном периоде</param>
            public InlineResponse2001Builder PeriodMonths(int? value)
            {
                _PeriodMonths = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.PeriodPrice property.
            /// </summary>
            /// <param name="value">Стоимость оплаченного периода</param>
            public InlineResponse2001Builder PeriodPrice(decimal? value)
            {
                _PeriodPrice = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.Expires property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2001Builder Expires(string value)
            {
                _Expires = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.ExternalCurrencySpelledPrefix property.
            /// </summary>
            /// <param name="value">Префикс для вывода текущей валюты хостинга (например, в строке &#39;$100&#39; префиксом является &#39;$&#39;)</param>
            public InlineResponse2001Builder ExternalCurrencySpelledPrefix(string value)
            {
                _ExternalCurrencySpelledPrefix = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2001.ExternalCurrencySpelledSuffix property.
            /// </summary>
            /// <param name="value">Суффикс для вывода текущей валюты хостинга (например, в строке &#39;100 руб.&#39; суффиксом является &#39; руб.&#39;</param>
            public InlineResponse2001Builder ExternalCurrencySpelledSuffix(string value)
            {
                _ExternalCurrencySpelledSuffix = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2001.
            /// </summary>
            /// <returns>InlineResponse2001</returns>
            public InlineResponse2001 Build()
            {
                Validate();
                return new InlineResponse2001(
                    Id: _Id,
                    Description: _Description,
                    BillingGroupId: _BillingGroupId,
                    Blocked: _Blocked,
                    BlockedDate: _BlockedDate,
                    BlockedReason: _BlockedReason,
                    CreditLimit: _CreditLimit,
                    PlanId: _PlanId,
                    PeriodId: _PeriodId,
                    ContractType: _ContractType,
                    ClientId: _ClientId,
                    ClientLogin: _ClientLogin,
                    ContractId: _ContractId,
                    NameRus: _NameRus,
                    NameEng: _NameEng,
                    Email: _Email,
                    StatSites: _StatSites,
                    StatSizeMb: _StatSizeMb,
                    StatEmails: _StatEmails,
                    StatMysqls: _StatMysqls,
                    StatTech: _StatTech,
                    StatNicd: _StatNicd,
                    StatAccessDynamic: _StatAccessDynamic,
                    StatAccessStatic: _StatAccessStatic,
                    StatAccessTraffic: _StatAccessTraffic,
                    StatPaidTotal: _StatPaidTotal,
                    StatVdsSize: _StatVdsSize,
                    PlanName: _PlanName,
                    PeriodMonths: _PeriodMonths,
                    PeriodPrice: _PeriodPrice,
                    Expires: _Expires,
                    ExternalCurrencySpelledPrefix: _ExternalCurrencySpelledPrefix,
                    ExternalCurrencySpelledSuffix: _ExternalCurrencySpelledSuffix
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_Description == null)
                {
                    throw new ArgumentException("Description is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_BillingGroupId == null)
                {
                    throw new ArgumentException("BillingGroupId is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_Blocked == null)
                {
                    throw new ArgumentException("Blocked is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_CreditLimit == null)
                {
                    throw new ArgumentException("CreditLimit is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_PlanId == null)
                {
                    throw new ArgumentException("PlanId is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_PeriodId == null)
                {
                    throw new ArgumentException("PeriodId is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_ContractType == null)
                {
                    throw new ArgumentException("ContractType is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_ClientId == null)
                {
                    throw new ArgumentException("ClientId is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_ClientLogin == null)
                {
                    throw new ArgumentException("ClientLogin is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_ContractId == null)
                {
                    throw new ArgumentException("ContractId is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_NameRus == null)
                {
                    throw new ArgumentException("NameRus is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_NameEng == null)
                {
                    throw new ArgumentException("NameEng is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_Email == null)
                {
                    throw new ArgumentException("Email is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatSites == null)
                {
                    throw new ArgumentException("StatSites is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatSizeMb == null)
                {
                    throw new ArgumentException("StatSizeMb is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatEmails == null)
                {
                    throw new ArgumentException("StatEmails is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatMysqls == null)
                {
                    throw new ArgumentException("StatMysqls is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatTech == null)
                {
                    throw new ArgumentException("StatTech is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatNicd == null)
                {
                    throw new ArgumentException("StatNicd is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatAccessDynamic == null)
                {
                    throw new ArgumentException("StatAccessDynamic is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatAccessStatic == null)
                {
                    throw new ArgumentException("StatAccessStatic is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatAccessTraffic == null)
                {
                    throw new ArgumentException("StatAccessTraffic is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatPaidTotal == null)
                {
                    throw new ArgumentException("StatPaidTotal is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_StatVdsSize == null)
                {
                    throw new ArgumentException("StatVdsSize is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_PlanName == null)
                {
                    throw new ArgumentException("PlanName is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_PeriodMonths == null)
                {
                    throw new ArgumentException("PeriodMonths is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_PeriodPrice == null)
                {
                    throw new ArgumentException("PeriodPrice is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_Expires == null)
                {
                    throw new ArgumentException("Expires is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_ExternalCurrencySpelledPrefix == null)
                {
                    throw new ArgumentException("ExternalCurrencySpelledPrefix is a required property for InlineResponse2001 and cannot be null");
                } 
                if (_ExternalCurrencySpelledSuffix == null)
                {
                    throw new ArgumentException("ExternalCurrencySpelledSuffix is a required property for InlineResponse2001 and cannot be null");
                } 
            }
        }

        
    }
}
