using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse20010
    /// </summary>
    public sealed class InlineResponse20010:  IEquatable<InlineResponse20010>
    { 
        /// <summary>
        /// Идентификатор записи
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// Дата и время создания записи
        /// </summary>
        public string Datetime { get; private set; }

        /// <summary>
        /// Тело сообщения (с HTML-тэгами)
        /// </summary>
        public string Description { get; private set; }

        /// <summary>
        /// Тело сообщения (без тэгов)
        /// </summary>
        public string DescriptionPlain { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse20010.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse20010()
        {
        }

        private InlineResponse20010(int? Id, string Datetime, string Description, string DescriptionPlain)
        {
            
            this.Id = Id;
            
            this.Datetime = Datetime;
            
            this.Description = Description;
            
            this.DescriptionPlain = DescriptionPlain;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse20010.
        /// </summary>
        /// <returns>InlineResponse20010Builder</returns>
        public static InlineResponse20010Builder Builder()
        {
            return new InlineResponse20010Builder();
        }

        /// <summary>
        /// Returns InlineResponse20010Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse20010Builder</returns>
        public InlineResponse20010Builder With()
        {
            return Builder()
                .Id(Id)
                .Datetime(Datetime)
                .Description(Description)
                .DescriptionPlain(DescriptionPlain);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse20010 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse20010.
        /// </summary>
        /// <param name="left">Compared (InlineResponse20010</param>
        /// <param name="right">Compared (InlineResponse20010</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse20010 left, InlineResponse20010 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse20010.
        /// </summary>
        /// <param name="left">Compared (InlineResponse20010</param>
        /// <param name="right">Compared (InlineResponse20010</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse20010 left, InlineResponse20010 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse20010.
        /// </summary>
        public sealed class InlineResponse20010Builder
        {
            private int? _Id;
            private string _Datetime;
            private string _Description;
            private string _DescriptionPlain;

            internal InlineResponse20010Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse20010.Id property.
            /// </summary>
            /// <param name="value">Идентификатор записи</param>
            public InlineResponse20010Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20010.Datetime property.
            /// </summary>
            /// <param name="value">Дата и время создания записи</param>
            public InlineResponse20010Builder Datetime(string value)
            {
                _Datetime = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20010.Description property.
            /// </summary>
            /// <param name="value">Тело сообщения (с HTML-тэгами)</param>
            public InlineResponse20010Builder Description(string value)
            {
                _Description = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20010.DescriptionPlain property.
            /// </summary>
            /// <param name="value">Тело сообщения (без тэгов)</param>
            public InlineResponse20010Builder DescriptionPlain(string value)
            {
                _DescriptionPlain = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse20010.
            /// </summary>
            /// <returns>InlineResponse20010</returns>
            public InlineResponse20010 Build()
            {
                Validate();
                return new InlineResponse20010(
                    Id: _Id,
                    Datetime: _Datetime,
                    Description: _Description,
                    DescriptionPlain: _DescriptionPlain
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse20010 and cannot be null");
                } 
                if (_Datetime == null)
                {
                    throw new ArgumentException("Datetime is a required property for InlineResponse20010 and cannot be null");
                } 
                if (_Description == null)
                {
                    throw new ArgumentException("Description is a required property for InlineResponse20010 and cannot be null");
                } 
                if (_DescriptionPlain == null)
                {
                    throw new ArgumentException("DescriptionPlain is a required property for InlineResponse20010 and cannot be null");
                } 
            }
        }

        
    }
}
