using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse20011
    /// </summary>
    public sealed class InlineResponse20011:  IEquatable<InlineResponse20011>
    { 
        /// <summary>
        /// IP-адрес
        /// </summary>
        public string Ip { get; private set; }

        /// <summary>
        /// идентификатор VDS
        /// </summary>
        public int? VdsId { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse20011.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse20011()
        {
        }

        private InlineResponse20011(string Ip, int? VdsId)
        {
            
            this.Ip = Ip;
            
            this.VdsId = VdsId;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse20011.
        /// </summary>
        /// <returns>InlineResponse20011Builder</returns>
        public static InlineResponse20011Builder Builder()
        {
            return new InlineResponse20011Builder();
        }

        /// <summary>
        /// Returns InlineResponse20011Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse20011Builder</returns>
        public InlineResponse20011Builder With()
        {
            return Builder()
                .Ip(Ip)
                .VdsId(VdsId);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse20011 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse20011.
        /// </summary>
        /// <param name="left">Compared (InlineResponse20011</param>
        /// <param name="right">Compared (InlineResponse20011</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse20011 left, InlineResponse20011 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse20011.
        /// </summary>
        /// <param name="left">Compared (InlineResponse20011</param>
        /// <param name="right">Compared (InlineResponse20011</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse20011 left, InlineResponse20011 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse20011.
        /// </summary>
        public sealed class InlineResponse20011Builder
        {
            private string _Ip;
            private int? _VdsId;

            internal InlineResponse20011Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse20011.Ip property.
            /// </summary>
            /// <param name="value">IP-адрес</param>
            public InlineResponse20011Builder Ip(string value)
            {
                _Ip = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20011.VdsId property.
            /// </summary>
            /// <param name="value">идентификатор VDS</param>
            public InlineResponse20011Builder VdsId(int? value)
            {
                _VdsId = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse20011.
            /// </summary>
            /// <returns>InlineResponse20011</returns>
            public InlineResponse20011 Build()
            {
                Validate();
                return new InlineResponse20011(
                    Ip: _Ip,
                    VdsId: _VdsId
                );
            }

            private void Validate()
            { 
                if (_Ip == null)
                {
                    throw new ArgumentException("Ip is a required property for InlineResponse20011 and cannot be null");
                } 
                if (_VdsId == null)
                {
                    throw new ArgumentException("VdsId is a required property for InlineResponse20011 and cannot be null");
                } 
            }
        }

        
    }
}
