using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse20012
    /// </summary>
    public sealed class InlineResponse20012:  IEquatable<InlineResponse20012>
    { 
        /// <summary>
        /// идентификатор VDS
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// VDS удалён если true
        /// </summary>
        public bool? Deleted { get; private set; }

        /// <summary>
        /// VDS работает нормально если true
        /// </summary>
        public bool? Online { get; private set; }

        /// <summary>
        /// VDS остановлен если true
        /// </summary>
        public bool? Stopped { get; private set; }

        /// <summary>
        /// изначальный пароль администратора или root
        /// </summary>
        public string Pwd { get; private set; }

        /// <summary>
        /// шаблон, на основе которого был создан VDS
        /// </summary>
        public string Template { get; private set; }

        /// <summary>
        /// полное описание типа VDS
        /// </summary>
        public string TypeFull { get; private set; }

        /// <summary>
        /// MAC-адрес VDS
        /// </summary>
        public string PhysicalMac { get; private set; }

        /// <summary>
        /// тип VDS
        /// </summary>
        public string Type { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse20012.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse20012()
        {
        }

        private InlineResponse20012(int? Id, bool? Deleted, bool? Online, bool? Stopped, string Pwd, string Template, string TypeFull, string PhysicalMac, string Type)
        {
            
            this.Id = Id;
            
            this.Deleted = Deleted;
            
            this.Online = Online;
            
            this.Stopped = Stopped;
            
            this.Pwd = Pwd;
            
            this.Template = Template;
            
            this.TypeFull = TypeFull;
            
            this.PhysicalMac = PhysicalMac;
            
            this.Type = Type;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse20012.
        /// </summary>
        /// <returns>InlineResponse20012Builder</returns>
        public static InlineResponse20012Builder Builder()
        {
            return new InlineResponse20012Builder();
        }

        /// <summary>
        /// Returns InlineResponse20012Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse20012Builder</returns>
        public InlineResponse20012Builder With()
        {
            return Builder()
                .Id(Id)
                .Deleted(Deleted)
                .Online(Online)
                .Stopped(Stopped)
                .Pwd(Pwd)
                .Template(Template)
                .TypeFull(TypeFull)
                .PhysicalMac(PhysicalMac)
                .Type(Type);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse20012 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse20012.
        /// </summary>
        /// <param name="left">Compared (InlineResponse20012</param>
        /// <param name="right">Compared (InlineResponse20012</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse20012 left, InlineResponse20012 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse20012.
        /// </summary>
        /// <param name="left">Compared (InlineResponse20012</param>
        /// <param name="right">Compared (InlineResponse20012</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse20012 left, InlineResponse20012 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse20012.
        /// </summary>
        public sealed class InlineResponse20012Builder
        {
            private int? _Id;
            private bool? _Deleted;
            private bool? _Online;
            private bool? _Stopped;
            private string _Pwd;
            private string _Template;
            private string _TypeFull;
            private string _PhysicalMac;
            private string _Type;

            internal InlineResponse20012Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse20012.Id property.
            /// </summary>
            /// <param name="value">идентификатор VDS</param>
            public InlineResponse20012Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20012.Deleted property.
            /// </summary>
            /// <param name="value">VDS удалён если true</param>
            public InlineResponse20012Builder Deleted(bool? value)
            {
                _Deleted = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20012.Online property.
            /// </summary>
            /// <param name="value">VDS работает нормально если true</param>
            public InlineResponse20012Builder Online(bool? value)
            {
                _Online = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20012.Stopped property.
            /// </summary>
            /// <param name="value">VDS остановлен если true</param>
            public InlineResponse20012Builder Stopped(bool? value)
            {
                _Stopped = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20012.Pwd property.
            /// </summary>
            /// <param name="value">изначальный пароль администратора или root</param>
            public InlineResponse20012Builder Pwd(string value)
            {
                _Pwd = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20012.Template property.
            /// </summary>
            /// <param name="value">шаблон, на основе которого был создан VDS</param>
            public InlineResponse20012Builder Template(string value)
            {
                _Template = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20012.TypeFull property.
            /// </summary>
            /// <param name="value">полное описание типа VDS</param>
            public InlineResponse20012Builder TypeFull(string value)
            {
                _TypeFull = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20012.PhysicalMac property.
            /// </summary>
            /// <param name="value">MAC-адрес VDS</param>
            public InlineResponse20012Builder PhysicalMac(string value)
            {
                _PhysicalMac = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20012.Type property.
            /// </summary>
            /// <param name="value">тип VDS</param>
            public InlineResponse20012Builder Type(string value)
            {
                _Type = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse20012.
            /// </summary>
            /// <returns>InlineResponse20012</returns>
            public InlineResponse20012 Build()
            {
                Validate();
                return new InlineResponse20012(
                    Id: _Id,
                    Deleted: _Deleted,
                    Online: _Online,
                    Stopped: _Stopped,
                    Pwd: _Pwd,
                    Template: _Template,
                    TypeFull: _TypeFull,
                    PhysicalMac: _PhysicalMac,
                    Type: _Type
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse20012 and cannot be null");
                } 
                if (_Deleted == null)
                {
                    throw new ArgumentException("Deleted is a required property for InlineResponse20012 and cannot be null");
                } 
                if (_Online == null)
                {
                    throw new ArgumentException("Online is a required property for InlineResponse20012 and cannot be null");
                } 
                if (_Stopped == null)
                {
                    throw new ArgumentException("Stopped is a required property for InlineResponse20012 and cannot be null");
                } 
                if (_Pwd == null)
                {
                    throw new ArgumentException("Pwd is a required property for InlineResponse20012 and cannot be null");
                } 
                if (_Template == null)
                {
                    throw new ArgumentException("Template is a required property for InlineResponse20012 and cannot be null");
                } 
                if (_TypeFull == null)
                {
                    throw new ArgumentException("TypeFull is a required property for InlineResponse20012 and cannot be null");
                } 
                if (_PhysicalMac == null)
                {
                    throw new ArgumentException("PhysicalMac is a required property for InlineResponse20012 and cannot be null");
                } 
                if (_Type == null)
                {
                    throw new ArgumentException("Type is a required property for InlineResponse20012 and cannot be null");
                } 
            }
        }

        
    }
}
