using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse20013
    /// </summary>
    public sealed class InlineResponse20013:  IEquatable<InlineResponse20013>
    { 
        /// <summary>
        /// Тип VDS, для которого применим шаблон. Принимает значения &#39;hv&#39; и &#39;vz&#39;
        /// </summary>
        public string Type { get; private set; }

        /// <summary>
        /// Имя шаблона
        /// </summary>
        public string Template { get; private set; }

        /// <summary>
        /// Популярность
        /// </summary>
        public int? Popularity { get; private set; }

        /// <summary>
        /// Актуальность шаблона. 1 &#x3D; шаблон актуален
        /// </summary>
        public int? ActualTemplate { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse20013.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse20013()
        {
        }

        private InlineResponse20013(string Type, string Template, int? Popularity, int? ActualTemplate)
        {
            
            this.Type = Type;
            
            this.Template = Template;
            
            this.Popularity = Popularity;
            
            this.ActualTemplate = ActualTemplate;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse20013.
        /// </summary>
        /// <returns>InlineResponse20013Builder</returns>
        public static InlineResponse20013Builder Builder()
        {
            return new InlineResponse20013Builder();
        }

        /// <summary>
        /// Returns InlineResponse20013Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse20013Builder</returns>
        public InlineResponse20013Builder With()
        {
            return Builder()
                .Type(Type)
                .Template(Template)
                .Popularity(Popularity)
                .ActualTemplate(ActualTemplate);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse20013 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse20013.
        /// </summary>
        /// <param name="left">Compared (InlineResponse20013</param>
        /// <param name="right">Compared (InlineResponse20013</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse20013 left, InlineResponse20013 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse20013.
        /// </summary>
        /// <param name="left">Compared (InlineResponse20013</param>
        /// <param name="right">Compared (InlineResponse20013</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse20013 left, InlineResponse20013 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse20013.
        /// </summary>
        public sealed class InlineResponse20013Builder
        {
            private string _Type;
            private string _Template;
            private int? _Popularity;
            private int? _ActualTemplate;

            internal InlineResponse20013Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse20013.Type property.
            /// </summary>
            /// <param name="value">Тип VDS, для которого применим шаблон. Принимает значения &#39;hv&#39; и &#39;vz&#39;</param>
            public InlineResponse20013Builder Type(string value)
            {
                _Type = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20013.Template property.
            /// </summary>
            /// <param name="value">Имя шаблона</param>
            public InlineResponse20013Builder Template(string value)
            {
                _Template = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20013.Popularity property.
            /// </summary>
            /// <param name="value">Популярность</param>
            public InlineResponse20013Builder Popularity(int? value)
            {
                _Popularity = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse20013.ActualTemplate property.
            /// </summary>
            /// <param name="value">Актуальность шаблона. 1 &#x3D; шаблон актуален</param>
            public InlineResponse20013Builder ActualTemplate(int? value)
            {
                _ActualTemplate = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse20013.
            /// </summary>
            /// <returns>InlineResponse20013</returns>
            public InlineResponse20013 Build()
            {
                Validate();
                return new InlineResponse20013(
                    Type: _Type,
                    Template: _Template,
                    Popularity: _Popularity,
                    ActualTemplate: _ActualTemplate
                );
            }

            private void Validate()
            { 
                if (_Type == null)
                {
                    throw new ArgumentException("Type is a required property for InlineResponse20013 and cannot be null");
                } 
                if (_Template == null)
                {
                    throw new ArgumentException("Template is a required property for InlineResponse20013 and cannot be null");
                } 
                if (_Popularity == null)
                {
                    throw new ArgumentException("Popularity is a required property for InlineResponse20013 and cannot be null");
                } 
                if (_ActualTemplate == null)
                {
                    throw new ArgumentException("ActualTemplate is a required property for InlineResponse20013 and cannot be null");
                } 
            }
        }

        
    }
}
