using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2002
    /// </summary>
    public sealed class InlineResponse2002:  IEquatable<InlineResponse2002>
    { 
        /// <summary>
        /// идентификатор аккаунта
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// логин
        /// </summary>
        public string Name { get; private set; }

        /// <summary>
        /// идентификатор сервера. Если равен или больше 10000, то это Postgres. Иначе MySQL
        /// </summary>
        public string Server { get; private set; }

        /// <summary>
        /// пароль
        /// </summary>
        public string Pwd { get; private set; }

        /// <summary>
        /// суффикс домена сервера
        /// </summary>
        public string UrlSuffix { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2002.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2002()
        {
        }

        private InlineResponse2002(int? Id, string Name, string Server, string Pwd, string UrlSuffix)
        {
            
            this.Id = Id;
            
            this.Name = Name;
            
            this.Server = Server;
            
            this.Pwd = Pwd;
            
            this.UrlSuffix = UrlSuffix;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2002.
        /// </summary>
        /// <returns>InlineResponse2002Builder</returns>
        public static InlineResponse2002Builder Builder()
        {
            return new InlineResponse2002Builder();
        }

        /// <summary>
        /// Returns InlineResponse2002Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2002Builder</returns>
        public InlineResponse2002Builder With()
        {
            return Builder()
                .Id(Id)
                .Name(Name)
                .Server(Server)
                .Pwd(Pwd)
                .UrlSuffix(UrlSuffix);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2002 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2002.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2002</param>
        /// <param name="right">Compared (InlineResponse2002</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2002 left, InlineResponse2002 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2002.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2002</param>
        /// <param name="right">Compared (InlineResponse2002</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2002 left, InlineResponse2002 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2002.
        /// </summary>
        public sealed class InlineResponse2002Builder
        {
            private int? _Id;
            private string _Name;
            private string _Server;
            private string _Pwd;
            private string _UrlSuffix;

            internal InlineResponse2002Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2002.Id property.
            /// </summary>
            /// <param name="value">идентификатор аккаунта</param>
            public InlineResponse2002Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2002.Name property.
            /// </summary>
            /// <param name="value">логин</param>
            public InlineResponse2002Builder Name(string value)
            {
                _Name = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2002.Server property.
            /// </summary>
            /// <param name="value">идентификатор сервера. Если равен или больше 10000, то это Postgres. Иначе MySQL</param>
            public InlineResponse2002Builder Server(string value)
            {
                _Server = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2002.Pwd property.
            /// </summary>
            /// <param name="value">пароль</param>
            public InlineResponse2002Builder Pwd(string value)
            {
                _Pwd = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2002.UrlSuffix property.
            /// </summary>
            /// <param name="value">суффикс домена сервера</param>
            public InlineResponse2002Builder UrlSuffix(string value)
            {
                _UrlSuffix = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2002.
            /// </summary>
            /// <returns>InlineResponse2002</returns>
            public InlineResponse2002 Build()
            {
                Validate();
                return new InlineResponse2002(
                    Id: _Id,
                    Name: _Name,
                    Server: _Server,
                    Pwd: _Pwd,
                    UrlSuffix: _UrlSuffix
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse2002 and cannot be null");
                } 
                if (_Name == null)
                {
                    throw new ArgumentException("Name is a required property for InlineResponse2002 and cannot be null");
                } 
                if (_Server == null)
                {
                    throw new ArgumentException("Server is a required property for InlineResponse2002 and cannot be null");
                } 
                if (_Pwd == null)
                {
                    throw new ArgumentException("Pwd is a required property for InlineResponse2002 and cannot be null");
                } 
                if (_UrlSuffix == null)
                {
                    throw new ArgumentException("UrlSuffix is a required property for InlineResponse2002 and cannot be null");
                } 
            }
        }

        
    }
}
