using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2003
    /// </summary>
    public sealed class InlineResponse2003:  IEquatable<InlineResponse2003>
    { 
        /// <summary>
        /// идентификатор домена
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// идентификатор связанной записи IIS
        /// </summary>
        public int? IisId { get; private set; }

        /// <summary>
        /// домен работает, если true
        /// </summary>
        public bool? Online { get; private set; }

        /// <summary>
        /// полное имя домена
        /// </summary>
        public string FullDomainName { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public string FullDomainNameLocal { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public string Addr1 { get; private set; }

        /// <summary>
        /// зона домена
        /// </summary>
        public string Zone { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2003.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2003()
        {
        }

        private InlineResponse2003(int? Id, int? IisId, bool? Online, string FullDomainName, string FullDomainNameLocal, string Addr1, string Zone)
        {
            
            this.Id = Id;
            
            this.IisId = IisId;
            
            this.Online = Online;
            
            this.FullDomainName = FullDomainName;
            
            this.FullDomainNameLocal = FullDomainNameLocal;
            
            this.Addr1 = Addr1;
            
            this.Zone = Zone;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2003.
        /// </summary>
        /// <returns>InlineResponse2003Builder</returns>
        public static InlineResponse2003Builder Builder()
        {
            return new InlineResponse2003Builder();
        }

        /// <summary>
        /// Returns InlineResponse2003Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2003Builder</returns>
        public InlineResponse2003Builder With()
        {
            return Builder()
                .Id(Id)
                .IisId(IisId)
                .Online(Online)
                .FullDomainName(FullDomainName)
                .FullDomainNameLocal(FullDomainNameLocal)
                .Addr1(Addr1)
                .Zone(Zone);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2003 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2003.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2003</param>
        /// <param name="right">Compared (InlineResponse2003</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2003 left, InlineResponse2003 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2003.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2003</param>
        /// <param name="right">Compared (InlineResponse2003</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2003 left, InlineResponse2003 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2003.
        /// </summary>
        public sealed class InlineResponse2003Builder
        {
            private int? _Id;
            private int? _IisId;
            private bool? _Online;
            private string _FullDomainName;
            private string _FullDomainNameLocal;
            private string _Addr1;
            private string _Zone;

            internal InlineResponse2003Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2003.Id property.
            /// </summary>
            /// <param name="value">идентификатор домена</param>
            public InlineResponse2003Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2003.IisId property.
            /// </summary>
            /// <param name="value">идентификатор связанной записи IIS</param>
            public InlineResponse2003Builder IisId(int? value)
            {
                _IisId = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2003.Online property.
            /// </summary>
            /// <param name="value">домен работает, если true</param>
            public InlineResponse2003Builder Online(bool? value)
            {
                _Online = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2003.FullDomainName property.
            /// </summary>
            /// <param name="value">полное имя домена</param>
            public InlineResponse2003Builder FullDomainName(string value)
            {
                _FullDomainName = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2003.FullDomainNameLocal property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2003Builder FullDomainNameLocal(string value)
            {
                _FullDomainNameLocal = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2003.Addr1 property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2003Builder Addr1(string value)
            {
                _Addr1 = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2003.Zone property.
            /// </summary>
            /// <param name="value">зона домена</param>
            public InlineResponse2003Builder Zone(string value)
            {
                _Zone = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2003.
            /// </summary>
            /// <returns>InlineResponse2003</returns>
            public InlineResponse2003 Build()
            {
                Validate();
                return new InlineResponse2003(
                    Id: _Id,
                    IisId: _IisId,
                    Online: _Online,
                    FullDomainName: _FullDomainName,
                    FullDomainNameLocal: _FullDomainNameLocal,
                    Addr1: _Addr1,
                    Zone: _Zone
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse2003 and cannot be null");
                } 
                if (_IisId == null)
                {
                    throw new ArgumentException("IisId is a required property for InlineResponse2003 and cannot be null");
                } 
                if (_Online == null)
                {
                    throw new ArgumentException("Online is a required property for InlineResponse2003 and cannot be null");
                } 
                if (_FullDomainName == null)
                {
                    throw new ArgumentException("FullDomainName is a required property for InlineResponse2003 and cannot be null");
                } 
                if (_FullDomainNameLocal == null)
                {
                    throw new ArgumentException("FullDomainNameLocal is a required property for InlineResponse2003 and cannot be null");
                } 
                if (_Addr1 == null)
                {
                    throw new ArgumentException("Addr1 is a required property for InlineResponse2003 and cannot be null");
                } 
                if (_Zone == null)
                {
                    throw new ArgumentException("Zone is a required property for InlineResponse2003 and cannot be null");
                } 
            }
        }

        
    }
}
