using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2004
    /// </summary>
    public sealed class InlineResponse2004:  IEquatable<InlineResponse2004>
    { 
        /// <summary>
        /// Дата последнего обновления домена
        /// </summary>
        public string DateUpdated { get; private set; }

        /// <summary>
        /// Дата создания записи
        /// </summary>
        public string RecordCreated { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public string SubjectContract { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public string EndDate { get; private set; }

        /// <summary>
        /// Дата, до которой оплачен домен
        /// </summary>
        public string PayedTill { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public string ObjectState { get; private set; }

        /// <summary>
        /// Имя домена
        /// </summary>
        public string DomainAddr { get; private set; }

        /// <summary>
        /// Сервера имён домена
        /// </summary>
        public string Nservers { get; private set; }

        /// <summary>
        /// Количество дней до окончания срока действия домена
        /// </summary>
        public int? ExpiresCountdown { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2004.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2004()
        {
        }

        private InlineResponse2004(string DateUpdated, string RecordCreated, string SubjectContract, string EndDate, string PayedTill, string ObjectState, string DomainAddr, string Nservers, int? ExpiresCountdown)
        {
            
            this.DateUpdated = DateUpdated;
            
            this.RecordCreated = RecordCreated;
            
            this.SubjectContract = SubjectContract;
            
            this.EndDate = EndDate;
            
            this.PayedTill = PayedTill;
            
            this.ObjectState = ObjectState;
            
            this.DomainAddr = DomainAddr;
            
            this.Nservers = Nservers;
            
            this.ExpiresCountdown = ExpiresCountdown;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2004.
        /// </summary>
        /// <returns>InlineResponse2004Builder</returns>
        public static InlineResponse2004Builder Builder()
        {
            return new InlineResponse2004Builder();
        }

        /// <summary>
        /// Returns InlineResponse2004Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2004Builder</returns>
        public InlineResponse2004Builder With()
        {
            return Builder()
                .DateUpdated(DateUpdated)
                .RecordCreated(RecordCreated)
                .SubjectContract(SubjectContract)
                .EndDate(EndDate)
                .PayedTill(PayedTill)
                .ObjectState(ObjectState)
                .DomainAddr(DomainAddr)
                .Nservers(Nservers)
                .ExpiresCountdown(ExpiresCountdown);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2004 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2004.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2004</param>
        /// <param name="right">Compared (InlineResponse2004</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2004 left, InlineResponse2004 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2004.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2004</param>
        /// <param name="right">Compared (InlineResponse2004</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2004 left, InlineResponse2004 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2004.
        /// </summary>
        public sealed class InlineResponse2004Builder
        {
            private string _DateUpdated;
            private string _RecordCreated;
            private string _SubjectContract;
            private string _EndDate;
            private string _PayedTill;
            private string _ObjectState;
            private string _DomainAddr;
            private string _Nservers;
            private int? _ExpiresCountdown;

            internal InlineResponse2004Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2004.DateUpdated property.
            /// </summary>
            /// <param name="value">Дата последнего обновления домена</param>
            public InlineResponse2004Builder DateUpdated(string value)
            {
                _DateUpdated = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2004.RecordCreated property.
            /// </summary>
            /// <param name="value">Дата создания записи</param>
            public InlineResponse2004Builder RecordCreated(string value)
            {
                _RecordCreated = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2004.SubjectContract property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2004Builder SubjectContract(string value)
            {
                _SubjectContract = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2004.EndDate property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2004Builder EndDate(string value)
            {
                _EndDate = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2004.PayedTill property.
            /// </summary>
            /// <param name="value">Дата, до которой оплачен домен</param>
            public InlineResponse2004Builder PayedTill(string value)
            {
                _PayedTill = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2004.ObjectState property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2004Builder ObjectState(string value)
            {
                _ObjectState = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2004.DomainAddr property.
            /// </summary>
            /// <param name="value">Имя домена</param>
            public InlineResponse2004Builder DomainAddr(string value)
            {
                _DomainAddr = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2004.Nservers property.
            /// </summary>
            /// <param name="value">Сервера имён домена</param>
            public InlineResponse2004Builder Nservers(string value)
            {
                _Nservers = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2004.ExpiresCountdown property.
            /// </summary>
            /// <param name="value">Количество дней до окончания срока действия домена</param>
            public InlineResponse2004Builder ExpiresCountdown(int? value)
            {
                _ExpiresCountdown = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2004.
            /// </summary>
            /// <returns>InlineResponse2004</returns>
            public InlineResponse2004 Build()
            {
                Validate();
                return new InlineResponse2004(
                    DateUpdated: _DateUpdated,
                    RecordCreated: _RecordCreated,
                    SubjectContract: _SubjectContract,
                    EndDate: _EndDate,
                    PayedTill: _PayedTill,
                    ObjectState: _ObjectState,
                    DomainAddr: _DomainAddr,
                    Nservers: _Nservers,
                    ExpiresCountdown: _ExpiresCountdown
                );
            }

            private void Validate()
            { 
                if (_DateUpdated == null)
                {
                    throw new ArgumentException("DateUpdated is a required property for InlineResponse2004 and cannot be null");
                } 
                if (_RecordCreated == null)
                {
                    throw new ArgumentException("RecordCreated is a required property for InlineResponse2004 and cannot be null");
                } 
                if (_SubjectContract == null)
                {
                    throw new ArgumentException("SubjectContract is a required property for InlineResponse2004 and cannot be null");
                } 
                if (_EndDate == null)
                {
                    throw new ArgumentException("EndDate is a required property for InlineResponse2004 and cannot be null");
                } 
                if (_PayedTill == null)
                {
                    throw new ArgumentException("PayedTill is a required property for InlineResponse2004 and cannot be null");
                } 
                if (_ObjectState == null)
                {
                    throw new ArgumentException("ObjectState is a required property for InlineResponse2004 and cannot be null");
                } 
                if (_DomainAddr == null)
                {
                    throw new ArgumentException("DomainAddr is a required property for InlineResponse2004 and cannot be null");
                } 
                if (_Nservers == null)
                {
                    throw new ArgumentException("Nservers is a required property for InlineResponse2004 and cannot be null");
                } 
                if (_ExpiresCountdown == null)
                {
                    throw new ArgumentException("ExpiresCountdown is a required property for InlineResponse2004 and cannot be null");
                } 
            }
        }

        
    }
}
