using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2005
    /// </summary>
    public sealed class InlineResponse2005:  IEquatable<InlineResponse2005>
    { 
        /// <summary>
        /// идентификатор псевдонима
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// почтовый ящик псевдонима
        /// </summary>
        public string Mail { get; private set; }

        /// <summary>
        /// имя псевдонима
        /// </summary>
        public string Alias { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2005.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2005()
        {
        }

        private InlineResponse2005(int? Id, string Mail, string Alias)
        {
            
            this.Id = Id;
            
            this.Mail = Mail;
            
            this.Alias = Alias;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2005.
        /// </summary>
        /// <returns>InlineResponse2005Builder</returns>
        public static InlineResponse2005Builder Builder()
        {
            return new InlineResponse2005Builder();
        }

        /// <summary>
        /// Returns InlineResponse2005Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2005Builder</returns>
        public InlineResponse2005Builder With()
        {
            return Builder()
                .Id(Id)
                .Mail(Mail)
                .Alias(Alias);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2005 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2005.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2005</param>
        /// <param name="right">Compared (InlineResponse2005</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2005 left, InlineResponse2005 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2005.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2005</param>
        /// <param name="right">Compared (InlineResponse2005</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2005 left, InlineResponse2005 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2005.
        /// </summary>
        public sealed class InlineResponse2005Builder
        {
            private int? _Id;
            private string _Mail;
            private string _Alias;

            internal InlineResponse2005Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2005.Id property.
            /// </summary>
            /// <param name="value">идентификатор псевдонима</param>
            public InlineResponse2005Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2005.Mail property.
            /// </summary>
            /// <param name="value">почтовый ящик псевдонима</param>
            public InlineResponse2005Builder Mail(string value)
            {
                _Mail = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2005.Alias property.
            /// </summary>
            /// <param name="value">имя псевдонима</param>
            public InlineResponse2005Builder Alias(string value)
            {
                _Alias = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2005.
            /// </summary>
            /// <returns>InlineResponse2005</returns>
            public InlineResponse2005 Build()
            {
                Validate();
                return new InlineResponse2005(
                    Id: _Id,
                    Mail: _Mail,
                    Alias: _Alias
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse2005 and cannot be null");
                } 
                if (_Mail == null)
                {
                    throw new ArgumentException("Mail is a required property for InlineResponse2005 and cannot be null");
                } 
                if (_Alias == null)
                {
                    throw new ArgumentException("Alias is a required property for InlineResponse2005 and cannot be null");
                } 
            }
        }

        
    }
}
