using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2006
    /// </summary>
    public sealed class InlineResponse2006:  IEquatable<InlineResponse2006>
    { 
        /// <summary>
        /// идентификатор ящика
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? Status { get; private set; }

        /// <summary>
        /// ящик работает, если true
        /// </summary>
        public bool? Online { get; private set; }

        /// <summary>
        /// полный адрес ящика
        /// </summary>
        public string Mail { get; private set; }

        /// <summary>
        /// имя пользователя для входа в Mercury
        /// </summary>
        public string MercuryUser { get; private set; }

        /// <summary>
        /// пароль для входа в Mercury
        /// </summary>
        public string MercuryPwd { get; private set; }

        /// <summary>
        /// текущий размер ящика
        /// </summary>
        public int? SizeAmount { get; private set; }

        /// <summary>
        /// количество файлов, занятых ящиком
        /// </summary>
        public int? SizeFileCount { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public int? ArchivedCount { get; private set; }

        /// <summary>
        /// адрес сервера для доступа к ящику по POP3
        /// </summary>
        public string ServerPop3 { get; private set; }

        /// <summary>
        /// адрес сервера для доступа к ящику по SMTP
        /// </summary>
        public string ServerSmtp { get; private set; }

        /// <summary>
        /// адрес сервера Webmail для входа в ящик через браузер
        /// </summary>
        public string ServerWebmail { get; private set; }

        /// <summary>
        /// адрес сервера для доступа к ящику по IMAP
        /// </summary>
        public string ServerImap { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public string Wm1 { get; private set; }

        /// <summary>
        /// 
        /// </summary>
        public string Wm2 { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2006.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2006()
        {
        }

        private InlineResponse2006(int? Id, int? Status, bool? Online, string Mail, string MercuryUser, string MercuryPwd, int? SizeAmount, int? SizeFileCount, int? ArchivedCount, string ServerPop3, string ServerSmtp, string ServerWebmail, string ServerImap, string Wm1, string Wm2)
        {
            
            this.Id = Id;
            
            this.Status = Status;
            
            this.Online = Online;
            
            this.Mail = Mail;
            
            this.MercuryUser = MercuryUser;
            
            this.MercuryPwd = MercuryPwd;
            
            this.SizeAmount = SizeAmount;
            
            this.SizeFileCount = SizeFileCount;
            
            this.ArchivedCount = ArchivedCount;
            
            this.ServerPop3 = ServerPop3;
            
            this.ServerSmtp = ServerSmtp;
            
            this.ServerWebmail = ServerWebmail;
            
            this.ServerImap = ServerImap;
            
            this.Wm1 = Wm1;
            
            this.Wm2 = Wm2;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2006.
        /// </summary>
        /// <returns>InlineResponse2006Builder</returns>
        public static InlineResponse2006Builder Builder()
        {
            return new InlineResponse2006Builder();
        }

        /// <summary>
        /// Returns InlineResponse2006Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2006Builder</returns>
        public InlineResponse2006Builder With()
        {
            return Builder()
                .Id(Id)
                .Status(Status)
                .Online(Online)
                .Mail(Mail)
                .MercuryUser(MercuryUser)
                .MercuryPwd(MercuryPwd)
                .SizeAmount(SizeAmount)
                .SizeFileCount(SizeFileCount)
                .ArchivedCount(ArchivedCount)
                .ServerPop3(ServerPop3)
                .ServerSmtp(ServerSmtp)
                .ServerWebmail(ServerWebmail)
                .ServerImap(ServerImap)
                .Wm1(Wm1)
                .Wm2(Wm2);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2006 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2006.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2006</param>
        /// <param name="right">Compared (InlineResponse2006</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2006 left, InlineResponse2006 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2006.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2006</param>
        /// <param name="right">Compared (InlineResponse2006</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2006 left, InlineResponse2006 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2006.
        /// </summary>
        public sealed class InlineResponse2006Builder
        {
            private int? _Id;
            private int? _Status;
            private bool? _Online;
            private string _Mail;
            private string _MercuryUser;
            private string _MercuryPwd;
            private int? _SizeAmount;
            private int? _SizeFileCount;
            private int? _ArchivedCount;
            private string _ServerPop3;
            private string _ServerSmtp;
            private string _ServerWebmail;
            private string _ServerImap;
            private string _Wm1;
            private string _Wm2;

            internal InlineResponse2006Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2006.Id property.
            /// </summary>
            /// <param name="value">идентификатор ящика</param>
            public InlineResponse2006Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.Status property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2006Builder Status(int? value)
            {
                _Status = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.Online property.
            /// </summary>
            /// <param name="value">ящик работает, если true</param>
            public InlineResponse2006Builder Online(bool? value)
            {
                _Online = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.Mail property.
            /// </summary>
            /// <param name="value">полный адрес ящика</param>
            public InlineResponse2006Builder Mail(string value)
            {
                _Mail = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.MercuryUser property.
            /// </summary>
            /// <param name="value">имя пользователя для входа в Mercury</param>
            public InlineResponse2006Builder MercuryUser(string value)
            {
                _MercuryUser = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.MercuryPwd property.
            /// </summary>
            /// <param name="value">пароль для входа в Mercury</param>
            public InlineResponse2006Builder MercuryPwd(string value)
            {
                _MercuryPwd = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.SizeAmount property.
            /// </summary>
            /// <param name="value">текущий размер ящика</param>
            public InlineResponse2006Builder SizeAmount(int? value)
            {
                _SizeAmount = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.SizeFileCount property.
            /// </summary>
            /// <param name="value">количество файлов, занятых ящиком</param>
            public InlineResponse2006Builder SizeFileCount(int? value)
            {
                _SizeFileCount = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.ArchivedCount property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2006Builder ArchivedCount(int? value)
            {
                _ArchivedCount = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.ServerPop3 property.
            /// </summary>
            /// <param name="value">адрес сервера для доступа к ящику по POP3</param>
            public InlineResponse2006Builder ServerPop3(string value)
            {
                _ServerPop3 = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.ServerSmtp property.
            /// </summary>
            /// <param name="value">адрес сервера для доступа к ящику по SMTP</param>
            public InlineResponse2006Builder ServerSmtp(string value)
            {
                _ServerSmtp = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.ServerWebmail property.
            /// </summary>
            /// <param name="value">адрес сервера Webmail для входа в ящик через браузер</param>
            public InlineResponse2006Builder ServerWebmail(string value)
            {
                _ServerWebmail = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.ServerImap property.
            /// </summary>
            /// <param name="value">адрес сервера для доступа к ящику по IMAP</param>
            public InlineResponse2006Builder ServerImap(string value)
            {
                _ServerImap = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.Wm1 property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2006Builder Wm1(string value)
            {
                _Wm1 = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2006.Wm2 property.
            /// </summary>
            /// <param name="value"></param>
            public InlineResponse2006Builder Wm2(string value)
            {
                _Wm2 = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2006.
            /// </summary>
            /// <returns>InlineResponse2006</returns>
            public InlineResponse2006 Build()
            {
                Validate();
                return new InlineResponse2006(
                    Id: _Id,
                    Status: _Status,
                    Online: _Online,
                    Mail: _Mail,
                    MercuryUser: _MercuryUser,
                    MercuryPwd: _MercuryPwd,
                    SizeAmount: _SizeAmount,
                    SizeFileCount: _SizeFileCount,
                    ArchivedCount: _ArchivedCount,
                    ServerPop3: _ServerPop3,
                    ServerSmtp: _ServerSmtp,
                    ServerWebmail: _ServerWebmail,
                    ServerImap: _ServerImap,
                    Wm1: _Wm1,
                    Wm2: _Wm2
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_Status == null)
                {
                    throw new ArgumentException("Status is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_Online == null)
                {
                    throw new ArgumentException("Online is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_Mail == null)
                {
                    throw new ArgumentException("Mail is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_MercuryUser == null)
                {
                    throw new ArgumentException("MercuryUser is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_MercuryPwd == null)
                {
                    throw new ArgumentException("MercuryPwd is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_SizeAmount == null)
                {
                    throw new ArgumentException("SizeAmount is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_SizeFileCount == null)
                {
                    throw new ArgumentException("SizeFileCount is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_ArchivedCount == null)
                {
                    throw new ArgumentException("ArchivedCount is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_ServerPop3 == null)
                {
                    throw new ArgumentException("ServerPop3 is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_ServerSmtp == null)
                {
                    throw new ArgumentException("ServerSmtp is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_ServerWebmail == null)
                {
                    throw new ArgumentException("ServerWebmail is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_ServerImap == null)
                {
                    throw new ArgumentException("ServerImap is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_Wm1 == null)
                {
                    throw new ArgumentException("Wm1 is a required property for InlineResponse2006 and cannot be null");
                } 
                if (_Wm2 == null)
                {
                    throw new ArgumentException("Wm2 is a required property for InlineResponse2006 and cannot be null");
                } 
            }
        }

        
    }
}
