using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2007
    /// </summary>
    public sealed class InlineResponse2007:  IEquatable<InlineResponse2007>
    { 
        /// <summary>
        /// идентификатор аккаунта
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// логин
        /// </summary>
        public string Name { get; private set; }

        /// <summary>
        /// пароль
        /// </summary>
        public string Pwd { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2007.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2007()
        {
        }

        private InlineResponse2007(int? Id, string Name, string Pwd)
        {
            
            this.Id = Id;
            
            this.Name = Name;
            
            this.Pwd = Pwd;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2007.
        /// </summary>
        /// <returns>InlineResponse2007Builder</returns>
        public static InlineResponse2007Builder Builder()
        {
            return new InlineResponse2007Builder();
        }

        /// <summary>
        /// Returns InlineResponse2007Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2007Builder</returns>
        public InlineResponse2007Builder With()
        {
            return Builder()
                .Id(Id)
                .Name(Name)
                .Pwd(Pwd);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2007 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2007.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2007</param>
        /// <param name="right">Compared (InlineResponse2007</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2007 left, InlineResponse2007 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2007.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2007</param>
        /// <param name="right">Compared (InlineResponse2007</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2007 left, InlineResponse2007 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2007.
        /// </summary>
        public sealed class InlineResponse2007Builder
        {
            private int? _Id;
            private string _Name;
            private string _Pwd;

            internal InlineResponse2007Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2007.Id property.
            /// </summary>
            /// <param name="value">идентификатор аккаунта</param>
            public InlineResponse2007Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2007.Name property.
            /// </summary>
            /// <param name="value">логин</param>
            public InlineResponse2007Builder Name(string value)
            {
                _Name = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2007.Pwd property.
            /// </summary>
            /// <param name="value">пароль</param>
            public InlineResponse2007Builder Pwd(string value)
            {
                _Pwd = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2007.
            /// </summary>
            /// <returns>InlineResponse2007</returns>
            public InlineResponse2007 Build()
            {
                Validate();
                return new InlineResponse2007(
                    Id: _Id,
                    Name: _Name,
                    Pwd: _Pwd
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse2007 and cannot be null");
                } 
                if (_Name == null)
                {
                    throw new ArgumentException("Name is a required property for InlineResponse2007 and cannot be null");
                } 
                if (_Pwd == null)
                {
                    throw new ArgumentException("Pwd is a required property for InlineResponse2007 and cannot be null");
                } 
            }
        }

        
    }
}
