using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2008
    /// </summary>
    public sealed class InlineResponse2008:  IEquatable<InlineResponse2008>
    { 
        /// <summary>
        /// идентификатор сайта
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// сайт работает нормально если true
        /// </summary>
        public bool? Online { get; private set; }

        /// <summary>
        /// идентификатор связанного аккаунта FTP
        /// </summary>
        public int? FtpId { get; private set; }

        /// <summary>
        /// идентификатор связанной записи DNS
        /// </summary>
        public int? DnsId { get; private set; }

        /// <summary>
        /// размер занятого места
        /// </summary>
        public int? SizeAmount { get; private set; }

        /// <summary>
        /// количество файлов
        /// </summary>
        public int? SizeFileCount { get; private set; }

        /// <summary>
        /// ограничение на количество файлов
        /// </summary>
        public int? SizeFileCountLimit { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2008.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2008()
        {
        }

        private InlineResponse2008(int? Id, bool? Online, int? FtpId, int? DnsId, int? SizeAmount, int? SizeFileCount, int? SizeFileCountLimit)
        {
            
            this.Id = Id;
            
            this.Online = Online;
            
            this.FtpId = FtpId;
            
            this.DnsId = DnsId;
            
            this.SizeAmount = SizeAmount;
            
            this.SizeFileCount = SizeFileCount;
            
            this.SizeFileCountLimit = SizeFileCountLimit;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2008.
        /// </summary>
        /// <returns>InlineResponse2008Builder</returns>
        public static InlineResponse2008Builder Builder()
        {
            return new InlineResponse2008Builder();
        }

        /// <summary>
        /// Returns InlineResponse2008Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2008Builder</returns>
        public InlineResponse2008Builder With()
        {
            return Builder()
                .Id(Id)
                .Online(Online)
                .FtpId(FtpId)
                .DnsId(DnsId)
                .SizeAmount(SizeAmount)
                .SizeFileCount(SizeFileCount)
                .SizeFileCountLimit(SizeFileCountLimit);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2008 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2008.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2008</param>
        /// <param name="right">Compared (InlineResponse2008</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2008 left, InlineResponse2008 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2008.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2008</param>
        /// <param name="right">Compared (InlineResponse2008</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2008 left, InlineResponse2008 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2008.
        /// </summary>
        public sealed class InlineResponse2008Builder
        {
            private int? _Id;
            private bool? _Online;
            private int? _FtpId;
            private int? _DnsId;
            private int? _SizeAmount;
            private int? _SizeFileCount;
            private int? _SizeFileCountLimit;

            internal InlineResponse2008Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2008.Id property.
            /// </summary>
            /// <param name="value">идентификатор сайта</param>
            public InlineResponse2008Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2008.Online property.
            /// </summary>
            /// <param name="value">сайт работает нормально если true</param>
            public InlineResponse2008Builder Online(bool? value)
            {
                _Online = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2008.FtpId property.
            /// </summary>
            /// <param name="value">идентификатор связанного аккаунта FTP</param>
            public InlineResponse2008Builder FtpId(int? value)
            {
                _FtpId = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2008.DnsId property.
            /// </summary>
            /// <param name="value">идентификатор связанной записи DNS</param>
            public InlineResponse2008Builder DnsId(int? value)
            {
                _DnsId = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2008.SizeAmount property.
            /// </summary>
            /// <param name="value">размер занятого места</param>
            public InlineResponse2008Builder SizeAmount(int? value)
            {
                _SizeAmount = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2008.SizeFileCount property.
            /// </summary>
            /// <param name="value">количество файлов</param>
            public InlineResponse2008Builder SizeFileCount(int? value)
            {
                _SizeFileCount = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2008.SizeFileCountLimit property.
            /// </summary>
            /// <param name="value">ограничение на количество файлов</param>
            public InlineResponse2008Builder SizeFileCountLimit(int? value)
            {
                _SizeFileCountLimit = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2008.
            /// </summary>
            /// <returns>InlineResponse2008</returns>
            public InlineResponse2008 Build()
            {
                Validate();
                return new InlineResponse2008(
                    Id: _Id,
                    Online: _Online,
                    FtpId: _FtpId,
                    DnsId: _DnsId,
                    SizeAmount: _SizeAmount,
                    SizeFileCount: _SizeFileCount,
                    SizeFileCountLimit: _SizeFileCountLimit
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse2008 and cannot be null");
                } 
                if (_Online == null)
                {
                    throw new ArgumentException("Online is a required property for InlineResponse2008 and cannot be null");
                } 
                if (_FtpId == null)
                {
                    throw new ArgumentException("FtpId is a required property for InlineResponse2008 and cannot be null");
                } 
                if (_DnsId == null)
                {
                    throw new ArgumentException("DnsId is a required property for InlineResponse2008 and cannot be null");
                } 
                if (_SizeAmount == null)
                {
                    throw new ArgumentException("SizeAmount is a required property for InlineResponse2008 and cannot be null");
                } 
                if (_SizeFileCount == null)
                {
                    throw new ArgumentException("SizeFileCount is a required property for InlineResponse2008 and cannot be null");
                } 
                if (_SizeFileCountLimit == null)
                {
                    throw new ArgumentException("SizeFileCountLimit is a required property for InlineResponse2008 and cannot be null");
                } 
            }
        }

        
    }
}
