using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using Sharpility.Extensions;
using NodaTime;

namespace IO.Swagger.api.Models
{
    /// <summary>
    /// InlineResponse2009
    /// </summary>
    public sealed class InlineResponse2009:  IEquatable<InlineResponse2009>
    { 
        /// <summary>
        /// идентификатор аккаунта
        /// </summary>
        public int? Id { get; private set; }

        /// <summary>
        /// имя базы данных
        /// </summary>
        public string Db { get; private set; }

        /// <summary>
        /// адрес сервера
        /// </summary>
        public string Server { get; private set; }

        /// <summary>
        /// логин
        /// </summary>
        public string Name { get; private set; }

        /// <summary>
        /// пароль
        /// </summary>
        public string Pwd { get; private set; }


        /// <summary>
        /// Empty constructor required by some serializers.
        /// Use InlineResponse2009.Builder() for instance creation instead.
        /// </summary>
        [Obsolete]
        public InlineResponse2009()
        {
        }

        private InlineResponse2009(int? Id, string Db, string Server, string Name, string Pwd)
        {
            
            this.Id = Id;
            
            this.Db = Db;
            
            this.Server = Server;
            
            this.Name = Name;
            
            this.Pwd = Pwd;
            
        }

        /// <summary>
        /// Returns builder of InlineResponse2009.
        /// </summary>
        /// <returns>InlineResponse2009Builder</returns>
        public static InlineResponse2009Builder Builder()
        {
            return new InlineResponse2009Builder();
        }

        /// <summary>
        /// Returns InlineResponse2009Builder with properties set.
        /// Use it to change properties.
        /// </summary>
        /// <returns>InlineResponse2009Builder</returns>
        public InlineResponse2009Builder With()
        {
            return Builder()
                .Id(Id)
                .Db(Db)
                .Server(Server)
                .Name(Name)
                .Pwd(Pwd);
        }

        public override string ToString()
        {
            return this.PropertiesToString();
        }

        public override bool Equals(object obj)
        {
            return this.EqualsByProperties(obj);
        }

        public bool Equals(InlineResponse2009 other)
        {
            return Equals((object) other);
        }

        public override int GetHashCode()
        {
            return this.PropertiesHash();
        }

        /// <summary>
        /// Implementation of == operator for (InlineResponse2009.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2009</param>
        /// <param name="right">Compared (InlineResponse2009</param>
        /// <returns>true if compared items are equals, false otherwise</returns>
        public static bool operator == (InlineResponse2009 left, InlineResponse2009 right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// Implementation of != operator for (InlineResponse2009.
        /// </summary>
        /// <param name="left">Compared (InlineResponse2009</param>
        /// <param name="right">Compared (InlineResponse2009</param>
        /// <returns>true if compared items are not equals, false otherwise</returns>
        public static bool operator != (InlineResponse2009 left, InlineResponse2009 right)
        {
            return !Equals(left, right);
        }

        /// <summary>
        /// Builder of InlineResponse2009.
        /// </summary>
        public sealed class InlineResponse2009Builder
        {
            private int? _Id;
            private string _Db;
            private string _Server;
            private string _Name;
            private string _Pwd;

            internal InlineResponse2009Builder()
            {
                SetupDefaults();
            }

            private void SetupDefaults()
            {
            }

            /// <summary>
            /// Sets value for InlineResponse2009.Id property.
            /// </summary>
            /// <param name="value">идентификатор аккаунта</param>
            public InlineResponse2009Builder Id(int? value)
            {
                _Id = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2009.Db property.
            /// </summary>
            /// <param name="value">имя базы данных</param>
            public InlineResponse2009Builder Db(string value)
            {
                _Db = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2009.Server property.
            /// </summary>
            /// <param name="value">адрес сервера</param>
            public InlineResponse2009Builder Server(string value)
            {
                _Server = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2009.Name property.
            /// </summary>
            /// <param name="value">логин</param>
            public InlineResponse2009Builder Name(string value)
            {
                _Name = value;
                return this;
            }

            /// <summary>
            /// Sets value for InlineResponse2009.Pwd property.
            /// </summary>
            /// <param name="value">пароль</param>
            public InlineResponse2009Builder Pwd(string value)
            {
                _Pwd = value;
                return this;
            }


            /// <summary>
            /// Builds instance of InlineResponse2009.
            /// </summary>
            /// <returns>InlineResponse2009</returns>
            public InlineResponse2009 Build()
            {
                Validate();
                return new InlineResponse2009(
                    Id: _Id,
                    Db: _Db,
                    Server: _Server,
                    Name: _Name,
                    Pwd: _Pwd
                );
            }

            private void Validate()
            { 
                if (_Id == null)
                {
                    throw new ArgumentException("Id is a required property for InlineResponse2009 and cannot be null");
                } 
                if (_Db == null)
                {
                    throw new ArgumentException("Db is a required property for InlineResponse2009 and cannot be null");
                } 
                if (_Server == null)
                {
                    throw new ArgumentException("Server is a required property for InlineResponse2009 and cannot be null");
                } 
                if (_Name == null)
                {
                    throw new ArgumentException("Name is a required property for InlineResponse2009 and cannot be null");
                } 
                if (_Pwd == null)
                {
                    throw new ArgumentException("Pwd is a required property for InlineResponse2009 and cannot be null");
                } 
            }
        }

        
    }
}
